? ccraig@kermit.wreck.org
? changes
? changes.crat.1
? changes.crat.2
? changes.crat.3
? testcases.py
? Lib/test/test_rational.py
Index: Makefile.pre.in
===================================================================
RCS file: /cvsroot/python/python/dist/src/Makefile.pre.in,v
retrieving revision 1.99
diff -c -r1.99 Makefile.pre.in
*** Makefile.pre.in	29 Aug 2002 15:04:37 -0000	1.99
--- Makefile.pre.in	2 Oct 2002 15:24:57 -0000
***************
*** 266,271 ****
--- 266,272 ----
  		Objects/iterobject.o \
  		Objects/listobject.o \
  		Objects/longobject.o \
+ 		Objects/rationalobject.o \
  		Objects/dictobject.o \
  		Objects/methodobject.o \
  		Objects/moduleobject.o \
***************
*** 474,479 ****
--- 475,481 ----
  		Include/iterobject.h \
  		Include/listobject.h \
  		Include/longobject.h \
+ 		Include/rationalobject.h \
  		Include/methodobject.h \
  		Include/modsupport.h \
  		Include/moduleobject.h \
Index: Include/Python.h
===================================================================
RCS file: /cvsroot/python/python/dist/src/Include/Python.h,v
retrieving revision 2.57
diff -c -r2.57 Python.h
*** Include/Python.h	12 Aug 2002 07:21:56 -0000	2.57
--- Include/Python.h	2 Oct 2002 15:24:57 -0000
***************
*** 75,80 ****
--- 75,81 ----
  #include "intobject.h"
  #include "boolobject.h"
  #include "longobject.h"
+ #include "rationalobject.h"
  #include "floatobject.h"
  #ifndef WITHOUT_COMPLEX
  #include "complexobject.h"
Index: Lib/pickle.py
===================================================================
RCS file: /cvsroot/python/python/dist/src/Lib/pickle.py,v
retrieving revision 1.71
diff -c -r1.71 pickle.py
*** Lib/pickle.py	19 Sep 2002 23:00:12 -0000	1.71
--- Lib/pickle.py	2 Oct 2002 15:24:58 -0000
***************
*** 104,109 ****
--- 104,110 ----
  DICT            = 'd'
  EMPTY_DICT      = '}'
  APPENDS         = 'e'
+ RATIONAL        = 'f'
  GET             = 'g'
  BINGET          = 'h'
  INST            = 'i'
***************
*** 341,346 ****
--- 342,351 ----
          self.write(LONG + `object` + '\n')
      dispatch[LongType] = save_long
  
+     def save_rational(self, object):
+         self.write(RATIONAL + `object` + '\n')
+     dispatch[RationalType] = save_rational
+ 
      def save_float(self, object, pack=struct.pack):
          if self.bin:
              self.write(BINFLOAT + pack('>d', object))
***************
*** 732,737 ****
--- 737,746 ----
      def load_long(self):
          self.append(long(self.readline()[:-1], 0))
      dispatch[LONG] = load_long
+ 
+     def load_rational(self):
+         self.append(rational(self.readline()[:-1]))
+     dispatch[RATIONAL] = load_rational
  
      def load_float(self):
          self.append(float(self.readline()[:-1]))
Index: Lib/types.py
===================================================================
RCS file: /cvsroot/python/python/dist/src/Lib/types.py,v
retrieving revision 1.29
diff -c -r1.29 types.py
*** Lib/types.py	14 Jun 2002 20:41:13 -0000	1.29
--- Lib/types.py	2 Oct 2002 15:24:58 -0000
***************
*** 15,20 ****
--- 15,21 ----
  
  IntType = int
  LongType = long
+ RationalType = rational
  FloatType = float
  BooleanType = bool
  try:
Index: Modules/cPickle.c
===================================================================
RCS file: /cvsroot/python/python/dist/src/Modules/cPickle.c,v
retrieving revision 2.96
diff -c -r2.96 cPickle.c
*** Modules/cPickle.c	16 Sep 2002 17:26:23 -0000	2.96
--- Modules/cPickle.c	2 Oct 2002 15:24:59 -0000
***************
*** 33,38 ****
--- 33,39 ----
                  fits in a Python int, because the size of Python ints varies
                  across platforms.
  LONG            Long (unbounded) integer; repr(i), then newline.
+ RATIONAL        Rational; repr(i), then newline.
  -------------------------------------------------------------------------- */
  
  #define MARK        '('
***************
*** 62,67 ****
--- 63,69 ----
  #define DICT        'd'
  #define EMPTY_DICT  '}'
  #define APPENDS     'e'
+ #define RATIONAL    'f'
  #define GET         'g'
  #define BINGET      'h'
  #define INST        'i'
***************
*** 1032,1037 ****
--- 1034,1068 ----
  	return res;
  }
  
+ static int
+ save_rational(Picklerobject *self, PyObject *args)
+ {
+ 	int size, res = -1;
+ 	PyObject *repr = 0;
+ 	static char r = RATIONAL;
+ 
+ 	if (!( repr = PyObject_Repr(args)))
+ 		goto finally;
+ 
+ 	if ((size = PyString_Size(repr)) < 0)
+ 		goto finally;
+ 
+ 	if ((*self->write_func)(self, &r, 1) < 0)
+ 		goto finally;
+ 
+ 	if ((*self->write_func)(self,
+ 					    PyString_AS_STRING((PyStringObject *)repr),
+ 					    size) < 0)
+ 		goto finally;
+ 	if ((*self->write_func)(self, "\n", 1) < 0)
+ 		goto finally;
+ 
+ 	res = 0;
+  finally:
+ 	Py_XDECREF(repr);
+ 
+ 	return res;
+ }
  
  static int
  save_float(Picklerobject *self, PyObject *args) 
***************
*** 1987,1992 ****
--- 2018,2030 ----
  		}
  		break;
  
+         case 'r':
+ 		if (type == &PyRational_Type) {
+ 			res = save_rational(self, args);
+ 			goto finally;
+ 		}
+ 		break;
+ 		
          case 'd':
  		if (type == &PyDict_Type) {
  			res = save_dict(self, args);
***************
*** 2759,2764 ****
--- 2797,2826 ----
  	return res;
  }
  
+ static int
+ load_rational(Unpicklerobject *self) 
+ {
+ 	PyObject *l = 0;
+ 	char *end, *s;
+ 	int len, res = -1;
+ 
+ 	if ((len = (*self->readline_func)(self, &s)) < 0) return -1;
+ 	if (len < 2) return bad_readline();
+ 	if (!( s=pystrndup(s,len)))  return -1;
+ 
+ 	if (!( l = PyRational_FromString(s, &end))) 
+ 		goto finally;
+ 
+ 	free(s);
+ 	PDATA_PUSH(self->stack, l, -1);
+ 	return 0;
+ 
+   finally:
+ 	free(s);
+ 
+ 	return res;
+ }
+ 
  
  static int
  load_float(Unpicklerobject *self) 
***************
*** 3766,3771 ****
--- 3828,3838 ----
  
  		case LONG:
  			if (load_long(self) < 0)
+ 				break;
+ 			continue;
+ 
+ 		case RATIONAL:
+ 			if (load_rational(self) < 0)
  				break;
  			continue;
  
Index: Objects/floatobject.c
===================================================================
RCS file: /cvsroot/python/python/dist/src/Objects/floatobject.c,v
retrieving revision 2.115
diff -c -r2.115 floatobject.c
*** Objects/floatobject.c	19 Aug 2002 19:26:42 -0000	2.115
--- Objects/floatobject.c	2 Oct 2002 15:24:59 -0000
***************
*** 291,296 ****
--- 291,303 ----
  			return -1;
  		}
  	}
+ 	else if (PyRational_Check(obj)) {
+ 		*dbl = PyRational_AsDouble(obj);
+ 		if(*dbl == -1.0 && PyErr_Occurred()) {
+ 			*v = NULL;
+ 			return -1;
+ 		}
+ 	}
  	else {
  		Py_INCREF(Py_NotImplemented);
  		*v = Py_NotImplemented;
***************
*** 634,639 ****
--- 641,652 ----
  		Py_INCREF(*pw);
  		return 0;
  	}
+ 	else if (PyRational_Check(*pw)) {
+ 		*pw = PyFloat_FromDouble(PyRational_AsDouble(*pw));
+ 		Py_INCREF(*pv);
+ 		return 0;
+ 	}
+ 
  	return 1; /* Can't do it */
  }
  
Index: Objects/intobject.c
===================================================================
RCS file: /cvsroot/python/python/dist/src/Objects/intobject.c,v
retrieving revision 2.93
diff -c -r2.93 intobject.c
*** Objects/intobject.c	11 Sep 2002 19:00:52 -0000	2.93
--- Objects/intobject.c	2 Oct 2002 15:24:59 -0000
***************
*** 515,521 ****
  	   underflows to 0 gracefully if the long is too big to convert
  	   to float. */
  	if (PyInt_Check(v) && PyInt_Check(w))
! 		return PyFloat_Type.tp_as_number->nb_true_divide(v, w);
  	Py_INCREF(Py_NotImplemented);
  	return Py_NotImplemented;
  }
--- 515,521 ----
  	   underflows to 0 gracefully if the long is too big to convert
  	   to float. */
  	if (PyInt_Check(v) && PyInt_Check(w))
! 	  return PyRational_FromFactors(v, w);
  	Py_INCREF(Py_NotImplemented);
  	return Py_NotImplemented;
  }
Index: Objects/longobject.c
===================================================================
RCS file: /cvsroot/python/python/dist/src/Objects/longobject.c,v
retrieving revision 1.143
diff -c -r1.143 longobject.c
*** Objects/longobject.c	3 Sep 2002 20:10:45 -0000	1.143
--- Objects/longobject.c	2 Oct 2002 15:24:59 -0000
***************
*** 1980,2021 ****
  long_true_divide(PyObject *v, PyObject *w)
  {
  	PyLongObject *a, *b;
! 	double ad, bd;
! 	int aexp, bexp, failed;
  
  	CONVERT_BINOP(v, w, &a, &b);
! 	ad = _PyLong_AsScaledDouble((PyObject *)a, &aexp);
! 	bd = _PyLong_AsScaledDouble((PyObject *)b, &bexp);
! 	failed = (ad == -1.0 || bd == -1.0) && PyErr_Occurred();
  	Py_DECREF(a);
  	Py_DECREF(b);
! 	if (failed)
! 		return NULL;
! 
! 	if (bd == 0.0) {
! 		PyErr_SetString(PyExc_ZeroDivisionError,
! 			"long division or modulo by zero");
! 		return NULL;
! 	}
! 
! 	/* True value is very close to ad/bd * 2**(SHIFT*(aexp-bexp)) */
! 	ad /= bd;	/* overflow/underflow impossible here */
! 	aexp -= bexp;
! 	if (aexp > INT_MAX / SHIFT)
! 		goto overflow;
! 	else if (aexp < -(INT_MAX / SHIFT))
! 		return PyFloat_FromDouble(0.0);	/* underflow to 0 */
! 	errno = 0;
! 	ad = ldexp(ad, aexp * SHIFT);
! 	if (Py_OVERFLOWED(ad)) /* ignore underflow to 0.0 */
! 		goto overflow;
! 	return PyFloat_FromDouble(ad);
! 
! overflow:
! 	PyErr_SetString(PyExc_OverflowError,
! 		"long/long too large for a float");
! 	return NULL;
! 
  }
  
  static PyObject *
--- 1980,1992 ----
  long_true_divide(PyObject *v, PyObject *w)
  {
  	PyLongObject *a, *b;
! 	PyObject *r;
  
  	CONVERT_BINOP(v, w, &a, &b);
! 	r = PyRational_FromFactors((PyObject *)v, (PyObject *)w);
  	Py_DECREF(a);
  	Py_DECREF(b);
! 	return r;
  }
  
  static PyObject *
Index: Python/bltinmodule.c
===================================================================
RCS file: /cvsroot/python/python/dist/src/Python/bltinmodule.c,v
retrieving revision 2.265
diff -c -r2.265 bltinmodule.c
*** Python/bltinmodule.c	27 Aug 2002 16:58:00 -0000	2.265
--- Python/bltinmodule.c	2 Oct 2002 15:25:00 -0000
***************
*** 1788,1793 ****
--- 1788,1794 ----
  	SETBUILTIN("int",		&PyInt_Type);
  	SETBUILTIN("list",		&PyList_Type);
  	SETBUILTIN("long",		&PyLong_Type);
+ 	SETBUILTIN("rational",          &PyRational_Type);
  	SETBUILTIN("object",		&PyBaseObject_Type);
  	SETBUILTIN("slice",		&PySlice_Type);
  	SETBUILTIN("staticmethod",	&PyStaticMethod_Type);
*** /dev/null	Wed Oct  2 10:57:58 2002
--- Objects/rationalobject.c	Wed Oct  2 11:26:37 2002
***************
*** 0 ****
--- 1,1489 ----
+ /* Rational object
+ 
+   derived from cRat module by Christopher Craig.
+   last changed October 2002
+ */
+ 
+ #include "Python.h"
+ #include "structmember.h"
+ #include "longintrepr.h"
+ 
+ #include <ctype.h>
+ 
+ #define ABS(x) ((x) < 0 ? -(x) : (x))
+ 
+ /* checks for NULL returns */
+ #define CHECK(x) if(!(x)) goto onError
+ 
+ /* ensures that freed references are reset to NULL */
+ #define MYDECREF(x) { Py_DECREF(x); x=NULL; }
+ 
+ /* applies operation in place, also checks for null returns */
+ #define INPLACE1(op, x) { PyObject *tfoo; CHECK(tfoo=op(x)); \
+ 	Py_DECREF(x); x=tfoo; }
+ #define INPLACE(op, x, y) { PyObject *tfoo; CHECK(tfoo=op(x,y)); \
+ 					   Py_DECREF(x); x=tfoo; }
+ #define SIZE(x) (((PyLongObject *)x)->ob_size)
+ 
+ /* used for debugging */
+ #define PRINT_VAR(d, x) printf("%s: ", d); \
+ 				    PyObject_Print(x, stdout, 0); printf("\n");
+ 
+ #ifndef NDEBUG
+ #include <stdio.h>
+ #endif
+ 
+ /************************************************************
+   factor math:
+     the following allow me cheat like mad when taking the GCD
+ ************************************************************/
+ 
+ /* factor_normalize: remove leading zeros from a factor.
+    Exactly the same as long_normalize.	Used by shifts */
+ static PyLongObject *
+ factor_normalize(register PyLongObject *v)
+ {
+ 	int j = ABS(v->ob_size);
+ 	register int i = j;
+ 
+ 	while(i>0 && v->ob_digit[i-1]==0) --i;
+ 	if(i!=j) v->ob_size = (v->ob_size < 0) ? -(i) : i;
+ 	return v;
+ }
+ 
+ /* shift right by 'shift' places. sign of 'a' is ignored,
+    and result is always positive.
+    
+    This and lshift are mainly used to avoid having to construct
+    PyLong_Objects for the shift variables in _factor_gcd_fast */
+ static PyObject *
+ factor_rshift(PyObject *aa, long shift)
+ {
+ 	int wordshift, newsize, loshift, hishift, i, j;
+ 	digit lomask, himask;
+ 	PyLongObject *a=(PyLongObject *)aa;
+ 	PyLongObject *new;
+ 
+ 	wordshift = shift/SHIFT;
+ 	newsize=ABS(a->ob_size) - wordshift;
+ 	if(newsize <= 0) {
+ 		return (PyObject *)PyLong_FromLong(0L);
+ 	}
+ 	loshift = shift % SHIFT;
+ 	hishift = SHIFT - loshift;
+ 	lomask = ((digit)1 << hishift)-1;
+ 	himask = MASK ^ lomask;
+ 	new = _PyLong_New(newsize);
+ 	if (new==NULL) return NULL;
+ 	for(i=0, j=wordshift; i<newsize; i++, j++){
+ 		new->ob_digit[i] = (a->ob_digit[j]>>loshift)&lomask;
+ 		if (i+1<newsize)
+ 			new->ob_digit[i] |= (a->ob_digit[j+1]<<hishift)&himask;
+ 	}
+ 	return (PyObject *)factor_normalize(new);
+ }
+ 
+ /* same as rshift, but left shifts */
+ static PyObject *
+ factor_lshift(PyObject *aa, long shift)
+ {
+ 	PyLongObject *a = (PyLongObject *)aa;
+ 	PyLongObject *z;
+ 	int oldsize, newsize, wordshift, remshift, i, j;
+ 	twodigits accum=0;
+ 
+ 	wordshift = (int)shift/SHIFT;
+ 	remshift = (int)shift - wordshift * SHIFT;
+ 	oldsize = ABS(a->ob_size);
+ 	newsize = oldsize + wordshift;
+ 	if (remshift) ++newsize;
+ 	z = _PyLong_New(newsize);
+ 	if(z==NULL) return NULL;
+ 	for(i=0; i<wordshift; i++) z->ob_digit[i]=0;
+ 	for(i=wordshift, j=0; j<oldsize; i++, j++) {
+ 		accum |= a->ob_digit[j] << remshift;
+ 		z->ob_digit[i] = (digit)(accum & MASK);
+ 		accum >>= SHIFT;
+ 	}
+ 	if(remshift)
+ 		z->ob_digit[newsize-1] = (digit)accum;
+ 	else
+ 		assert(!accum);
+ 	return (PyObject *)factor_normalize(z);
+ }
+ 
+ /* exactly the same as long_muladd1, used to read decimal digits in
+    PyRational_FromString */
+ static PyObject *
+ factor_muladd1(PyObject *aa, wdigit n, twodigits carry)
+ {
+ 	int size_a = ABS(SIZE(aa));
+ 	PyLongObject *a = (PyLongObject *)aa;
+ 	PyLongObject *z = _PyLong_New(size_a+1);
+ 	int i;
+ 	
+ 	if (z == NULL)
+ 		return NULL;
+ 	for (i = 0; i < size_a; ++i) {
+ 		carry += (twodigits)a->ob_digit[i] * n;
+ 		z->ob_digit[i] = (digit) (carry & MASK);
+ 		carry >>= SHIFT;
+ 	}
+ 	z->ob_digit[i] = (digit) carry;
+ 	return (PyObject *)factor_normalize(z);
+ }
+ 
+ /* find how many places one must rshift to make a number odd
+    adds a great deal of performance to _factor_gcd_fast
+ */
+ static long
+ factor_findshift(PyObject *aa)
+ {
+ 	PyLongObject *f=(PyLongObject *)aa;
+ 	int mask = 1;
+ 	long bytenum = -1;
+ 	long i = 0;
+ 
+ 	/* find the first non-zero digit */
+ 	while(f->ob_digit[++bytenum]==0) i+=SHIFT;
+ 
+ 	/* find the first non-zero bit in that digit */
+ 	while(!((f->ob_digit[bytenum])&mask)) {
+ 		mask<<=1;
+ 		i++;
+ 	}
+ 	return i;
+ }
+ 
+ /* find gcd(aa, bb) where aa->size <= 2 */
+ static PyObject *
+ _factor_gcd_euclid1(PyObject *aa, PyObject *bb)
+ {
+ 	PyObject *bt;
+ 	register long a, b, t;
+ 
+ 	a = PyLong_AsLong(aa);
+ 	if(SIZE(bb)<=2) b=PyLong_AsLong(bb);
+ 	else {
+ 	  if((bt = PyNumber_Remainder(bb, aa))==NULL) return NULL;
+ 	  b = PyLong_AsLong(bt);
+ 	  Py_DECREF(bt);
+ 	}
+ 
+ 	while (b) {
+ 		t = a % b;
+ 		a = b;
+ 		b = t;
+ 	}
+ 
+ 	return PyLong_FromLong(a);
+ }
+ 
+ /* find gcd(a, b) where a<b */
+ static PyObject *
+ _factor_gcd_fast(PyObject *a, PyObject *b)
+ {
+ 	PyObject *t=NULL;
+ 	long shift;
+ 
+ 	Py_INCREF(a);
+ 	Py_INCREF(b);
+ 
+ 	/* if b is much larger than a then replace b
+ 	   with b%a to save work later */
+ 	if (SIZE(a) != SIZE(b)) {
+ 		CHECK(t = PyNumber_Remainder(b, a));
+ 		Py_DECREF(b);
+ 		b=t;
+ 		t=NULL;
+ 	}
+ 
+ 	/* if a divides b, return a */
+ 	if (SIZE(b) == 0) {
+ 		Py_DECREF(b);
+ 		return a;
+ 	}
+ 
+ 	{long shiftA, shiftB;
+ 	shiftA = factor_findshift(a);
+ 	shiftB = factor_findshift(b);
+ 	shift = (shiftA < shiftB ? shiftA : shiftB);
+ 	INPLACE(factor_rshift, a, shiftA);
+ 	INPLACE(factor_rshift, b, shiftB);
+ 	}
+ 
+ 	CHECK(t = PyNumber_Subtract(a, b));
+ 
+ 	while (SIZE(t)) {
+ 		long s;
+ 
+ 		s = factor_findshift(t);
+ 		if(SIZE(t)<0) {
+ 			Py_DECREF(b);
+ 			CHECK(b = factor_rshift(t, s));
+ 		}
+ 		else {
+ 			Py_DECREF(a);
+ 			CHECK(a = factor_rshift(t, s));
+ 		}
+ 		/* we are in the inner loop, so I'll do anything to save a cycle */
+ 		Py_DECREF(t);
+ 		CHECK(t = PyLong_Type.tp_as_number->nb_subtract(a, b));
+ 	}
+ 
+ 	Py_DECREF(t);
+ 	CHECK(t = factor_lshift(b, shift));
+ 	Py_DECREF(a);
+ 	Py_DECREF(b);
+ 
+ 	return t;
+ 
+  onError:
+ 	Py_XDECREF(a); Py_XDECREF(b); Py_XDECREF(t);
+ 	return NULL;
+ }
+ 
+ static PyObject *
+ factor_gcd(PyObject *aa, PyObject *bb)
+ {
+ 	/* History:
+ 
+ 	   There are two main ways to do GCD: Euclid's algorithm and a
+ 		binary method based on shifts and subtracts.
+ 
+ 	   Euclid takes less iterations, and takes time relative to the smaller
+ 	     of the two inputs. But requires divides which are very expensive
+ 		on large numbers.
+ 
+ 	   Binary uses much less expensive operations, but takes time relative
+ 	     to the larger input and takes more iterations than Euclid to
+ 		complete even if the numbers are similarly sized.
+ 
+ 	   I used to run Euclid iff the smaller element was less than half the
+ 		size of the larger, and this worked pretty well.	Then I was
+ 		thinking about the algorithms and the above properties and realized
+ 		that I could do it much faster if I made a hybrid method that given
+ 		(a < b) set b to b%a (reducing the problem space to the size of the
+ 		smaller input) and then used the binary method.
+ 
+ 	   I also included a fast method for dealing with single digit integers
+ 		that uses C ints rather than PyLongs as intermediate values, which
+ 		speeds up this case quite a bit.
+ 	*/
+ 
+ 	PyObject *a, *b, *z;
+ 	int sizea, sizeb;
+ 
+ 	if(!(a=PyNumber_Absolute(aa))) return NULL;
+ 	sizea=SIZE(a);
+ 	
+ 	if(!(b=PyNumber_Absolute(bb))) {
+ 		Py_DECREF(a);
+ 		return NULL;
+ 	}
+ 	sizeb=SIZE(b);
+ 	
+ 
+ 	if(sizea > sizeb) {
+ 		long t; PyObject *tf;
+ 		t = sizea; sizea = sizeb; sizeb = t;
+ 		tf = a; a=b; b=tf;
+ 	}
+ 
+ 	if(sizea == 0) {
+ 		Py_DECREF((PyObject *)a);
+ 		return (PyObject *)b;
+ 	}
+ 	else if(sizea <= 2) z = _factor_gcd_euclid1(a, b); 
+ 	else z = _factor_gcd_fast(a, b);
+ 
+ 	Py_DECREF(a);
+ 	Py_DECREF(b);
+ 	return z;
+ }
+ 
+ /************************************************************
+   Rational methods
+ 
+   the meat of the object
+ ************************************************************/
+ 
+ 
+ typedef struct {
+ 	PyObject_HEAD
+ 	PyObject *n; /* PyLong numerator */
+ 	PyObject *d; /* PyLong denominator */
+ } PyRational_Object;
+ 
+ PyDoc_STRVAR(rational_doc,
+ "rational(arg1, arg2) -> rational\n"
+ "arg1 and arg2 can be of type int, long, float, or string.	If string\n"
+ "then they must be of the form '<int>[.<int>]' or '<int>/<int>', \n"
+ "for example '12', '12.1', '12/3'	are valid strings.\n"
+ "\n"
+ "Rational objects have the single method self.trim() and the attributes\n"
+ 		   "self.numerator and self.denominator\n");
+ 
+ static PyObject *_PyRational_FROM_FACTORS(PyObject *zn, PyObject *zd);
+ 
+ /* converts an inputs.  accepts int, long, or rational */
+ static PyObject *
+ r_convert(PyObject *a)
+ {
+ 	if(a==NULL) {
+ 		return _PyRational_FROM_FACTORS(PyLong_FromLong(1),
+ 								 PyLong_FromLong(1));
+ 	}
+ 	else if(PyRational_Check(a)) {
+ 		Py_INCREF(a);
+ 		return a;
+ 	}
+ 	else if(PyInt_Check(a) || PyLong_Check(a)) {
+ 		return _PyRational_FROM_FACTORS(PyNumber_Long(a),
+ 								  PyLong_FromLong(1));
+ 	}
+ 	return NULL;
+ }
+ 
+ /* runs r_convert on a pair of inputs */
+ static int convert_binop(PyObject *v, PyObject *w,
+ 					PyRational_Object **a, PyRational_Object **b)
+ {
+ 	if(!(PyNumber_Check(v) && PyNumber_Check(w))) {
+ 		return 0;
+ 	}
+ 
+ 	if((*a=(PyRational_Object *)r_convert(v))==NULL) {
+ 		*b=NULL;
+ 		return 0;
+ 	}
+ 
+ 	if((*b=(PyRational_Object *)r_convert(w))==NULL) {
+ 		MYDECREF(*a);
+ 		return 0;
+ 	}
+ 	return 1;
+ }
+ 
+ #define CONVERT_BINOP(v, w, a, b) \
+ 	if (!convert_binop(v, w, a, b)) { \
+ 		Py_INCREF(Py_NotImplemented); \
+ 		return Py_NotImplemented; \
+      }
+ 
+ 
+ /* WARNING: Steals references */
+ static PyObject *
+ _PyRational_FROM_FACTORS(PyObject *zn, PyObject *zd)
+ {
+ 	PyRational_Object *z=NULL;
+ 
+ 	if (zn==NULL||zd==NULL) goto onError;
+ 	if(SIZE(zd) < 0) {
+ 		INPLACE1(PyNumber_Negative, zn);
+ 		INPLACE1(PyNumber_Negative, zd);
+ 	}
+ 
+ 	CHECK(z = PyObject_NEW(PyRational_Object, &PyRational_Type));
+ 	z->n = zn;
+ 	z->d = zd;
+ 	return (PyObject *)z;
+ 
+  onError:
+ 	Py_XDECREF(zn); Py_XDECREF(zd);
+ 	return NULL;
+ }
+ 
+ /* for export.	 Does not steal references, reduces factors */
+ PyObject *
+ PyRational_FromFactors(PyObject *v, PyObject *w)
+ {
+ 	PyObject *n, *d;
+ 	PyObject *zn, *zd, *g;
+ 
+ 	n=d=zn=zd=g=NULL;
+ 
+ 	if(!((PyInt_Check(v)||PyLong_Check(v))&&
+ 		(PyInt_Check(w)||PyLong_Check(w)))) {
+ 		PyErr_SetString(PyExc_TypeError,
+ 					 "arguments must be of type int or long");
+ 		return NULL;
+ 	}
+ 	
+ 	CHECK(n=PyNumber_Long(v));
+ 	CHECK(d=PyNumber_Long(w));
+ 	if(SIZE(d)==0) {
+ 		PyErr_SetString(PyExc_ZeroDivisionError, "divide by zero");
+ 		Py_DECREF(n);
+ 		Py_DECREF(d);
+ 		return NULL;
+ 	}
+ 
+ 	CHECK(g=factor_gcd(n, d));
+ 	CHECK(zn=PyNumber_FloorDivide(n, g));
+ 	CHECK(zd=PyNumber_FloorDivide(d, g));
+ 	Py_DECREF(n);
+ 	Py_DECREF(d);
+ 	Py_DECREF(g);
+ 	return _PyRational_FROM_FACTORS(zn, zd);
+ 
+  onError:
+ 	Py_XDECREF(zn);
+ 	Py_XDECREF(zd);
+ 	Py_XDECREF(g);
+ 	return NULL;
+ }
+ 	
+ 
+ void
+ PyRational_AsFactors(PyObject *r, PyObject **n, PyObject **d)
+ {
+ 	PyRational_Object *self=(PyRational_Object *)r;
+ 	
+ 	*n = self->n;
+ 	*d = self->d;
+ 	Py_INCREF(self->n);
+ 	Py_INCREF(self->d);
+ }
+ 
+ 
+ PyObject *
+ PyRational_FromString(char *s, char **end)
+ {
+      int sign=1, esign=1;
+      char *ts, *start=s;
+      PyObject *n, *d;
+      PyObject *exp;
+ 
+      n = PyLong_FromLong(0);
+      d = PyLong_FromLong(1);
+      exp = PyLong_FromLong(1);
+      CHECK(n&&d&&exp);
+ 
+      while(*s != '\0' && isspace(Py_CHARMASK(*s))) ++s;
+      if(*s == '+') ++s;
+      else if (*s == '-') {
+           ++s;
+           sign = -1;
+      }
+      
+      while (*s != '\0' && isspace(Py_CHARMASK(*s))) ++s;
+      if (*s == '.') goto strDecimal;
+      ts = s;
+ 
+      for(; n != NULL; ++s) {
+           int k = -1;
+           PyObject *t;
+ 
+           if (*s <= '9') k = *s - '0';
+           if (k < 0 || k > 9) break;
+ 
+           CHECK(t = factor_muladd1(n, (digit)10, (digit)k));
+           Py_DECREF(n);
+           n=t;
+      }
+ 
+      if (n == NULL) return NULL;
+      if (s == ts)
+           goto onError;
+ 
+      if (*s == 'L' || *s == 'l') ++s;
+      if (*s == '/') goto strFraction;
+      if (*s != '.')
+           goto strEnd;
+ 
+  strDecimal:
+      for(s++; n!=NULL && d!=NULL; ++s) {
+           int k = -1;
+           PyObject *tn;
+ 
+           if(*s <= '9') k = *s - '0';
+           if(k<0 || k > 9) break;
+ 
+           CHECK(tn = factor_muladd1(n, (digit)10, (digit)k));
+           Py_DECREF(n);
+           n = tn;
+           CHECK(tn = factor_muladd1(exp, (digit)10, (digit)0));
+ 	  Py_DECREF(exp);
+ 	  exp = tn;
+      }
+      
+      if(*s=='L' || *s == 'l') ++s;
+      while (*s != '\0' && isspace(Py_CHARMASK(*s))) ++s;
+ 
+      if (*s == '\0')
+           goto strEnd;
+ 
+  strFraction:
+      Py_DECREF(d);
+      CHECK(d = PyLong_FromLong(0));
+ 
+      if (*(++s) == '-') {
+ 	  esign=-1;
+ 	  s++;
+      }
+ 	else if (*s == '+') {
+ 	  s++;
+      }
+      
+      for(; d != NULL; ++s) {
+           int k = -1;
+           PyObject *t;
+ 
+           if (*s <= '9') k = *s - '0';
+           if (k < 0 || k > 9) break;
+ 
+           CHECK(t = factor_muladd1(d, (digit)10, (digit)k));
+           Py_DECREF(d);
+           d=t;
+      }
+ 
+ 	if(SIZE(d)==0) {
+ 		Py_XDECREF(n);
+ 		Py_XDECREF(d);
+ 		Py_XDECREF(exp);
+ 		PyErr_SetString(PyExc_ZeroDivisionError, "divide by zero");
+ 		return NULL;
+ 	}
+ 	
+      while (*s != '\0' && isspace(Py_CHARMASK(*s))) ++s;
+      if(*s != '\0') goto onError;
+ 
+  strEnd:
+ 	if (end)
+ 		*end = s;
+ 	else if (*s != '\0')
+ 		goto onError;
+ 	
+      INPLACE(PyNumber_Multiply, d, exp);
+      Py_DECREF(exp);
+ 
+      CHECK(exp = factor_gcd((PyObject *)n, (PyObject *)d));
+      INPLACE(PyNumber_FloorDivide, n, exp);
+      INPLACE(PyNumber_FloorDivide, d, exp);
+      Py_DECREF(exp);
+ 
+      return _PyRational_FROM_FACTORS(n, d);
+ 
+  onError:
+      Py_XDECREF(n); Py_XDECREF(d);
+      Py_XDECREF(exp); 
+      PyErr_Format(PyExc_ValueError,
+                   "invalid literal for rational(): %.200s", start);
+      return NULL;
+ }
+ 
+ PyObject *
+ PyRational_FromDouble(double s)
+ {
+ 	double base;
+ 	int exp, sign=1;
+ 	PyObject *n, *d, *t;
+ 
+ 	if(Py_IS_INFINITY(s)) {
+ 		PyErr_SetString(PyExc_OverflowError,
+ 					 "cannot convent unbounded float");
+ 		return NULL;
+ 	}
+ 
+ 	n = PyLong_FromLong(0);
+ 	d = PyLong_FromLong(1);
+ 	t = NULL;
+ 
+ 	CHECK(n&&d);
+ 
+ 	base = frexp(s, &exp);
+ 	if(base<0) {
+ 		sign=-1;
+ 		base=-base;
+ 	}
+ 
+ 	while(base) {
+ 		const int shift=SHIFT;
+ 		int t;
+ 		PyObject *f;
+ 
+ 		base = ldexp(base, shift);
+ 		t = floor(base);
+ 		base -= t;
+ 		exp -= shift;
+ 
+ 		CHECK(f = PyLong_FromLong((long)t));
+ 		INPLACE(factor_lshift, n, shift);
+ 		INPLACE(PyNumber_Add, n, f);
+ 		Py_DECREF(f);
+ 	}
+ 
+ 	if(exp > 0) {
+ 		INPLACE(factor_lshift, n, exp);
+ 	}
+ 	else {
+ 		INPLACE(factor_lshift, d, -exp);
+ 	}
+ 
+ 	if(sign < 0){
+ 		INPLACE1(PyNumber_Negative, n);
+ 	}
+ 	CHECK(t = factor_gcd(n, d));
+ 	INPLACE(PyNumber_FloorDivide, n, t);
+ 	INPLACE(PyNumber_FloorDivide, d, t);
+ 	Py_DECREF(t);
+ 
+ 	return _PyRational_FROM_FACTORS(n, d);
+ 
+  onError:
+ 	Py_XDECREF(t); Py_XDECREF(n); Py_XDECREF(d);
+ 	return NULL;
+ }
+ 
+ double 
+ PyRational_AsDouble(PyObject *r) 
+ {
+ 	PyRational_Object *self=(PyRational_Object *)r;
+ 	int size_n = ABS(SIZE(self->n)), size_d = ABS(SIZE(self->d)); 
+ 	int shift = (size_n-size_d-5)*SHIFT;
+ 	PyObject *tn, *t; 
+ 	double z;
+ 
+ 	tn=t=NULL;
+ 
+ 	/*********************************************************
+ 	 shifts such that n is exactly 5 digits (75 bits) longer
+ 	 than d, then creates float from floordivision
+ 
+ 	 result exponent is modified to account for shift
+ 	**********************************************************/
+ 
+ 	if (shift > 0) { 
+ 		CHECK(tn = factor_lshift(self->d, shift)); 
+ 		CHECK(t = PyNumber_FloorDivide(self->n, tn)); 
+ 		MYDECREF(tn); 
+ 	}
+ 	else if (shift < 0) { 
+ 		CHECK(tn = factor_lshift(self->n, -shift)); 
+ 		CHECK(t = PyNumber_FloorDivide(tn, self->d)); 
+ 		MYDECREF(tn); 
+ 	}
+ 	else { 
+ 		CHECK(t = PyNumber_FloorDivide(self->n, self->d)); 
+ 	} 
+ 
+ 	if((z = PyLong_AsDouble(t))==-1 && PyErr_Occurred()) goto onError;
+ 	Py_DECREF(t);
+ 	z = ldexp(z, shift);
+ 
+ 	if((z<0)^(SIZE(self->n)<0)) z=-z;
+ 
+ 	return z;
+ 
+  onError:
+ 	Py_XDECREF(tn); Py_XDECREF(t);
+ 	return -1;
+ 	
+ } 
+ 
+ 	
+ static PyObject *
+ rational_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
+ {
+ 	PyObject *aa, *bb;
+ 	PyObject *n, *d;
+ 
+ 	n=d=aa=bb=NULL;
+ 	if(!PyArg_ParseTuple(args, "|OO", &aa, &bb)) return NULL;
+ 
+ 	if(aa==NULL) {
+ 		/* no arguments, return 1 */
+ 		CHECK(n=PyLong_FromLong(0));
+ 		CHECK(d=PyLong_FromLong(1));
+ 		return _PyRational_FROM_FACTORS(n, d);
+ 	}
+ 
+ 	if(bb!=NULL) {
+ 		/* two arguments, both arguments must be int/longs */
+ 		if(!((PyInt_Check(aa)||PyLong_Check(aa))&&
+ 			(PyInt_Check(bb)||PyLong_Check(bb)))) {
+ 			PyErr_SetString(PyExc_TypeError,
+ 				"if two args given, both must be of type int or long");
+ 			return NULL;
+ 		}
+ 		CHECK(n=PyNumber_Long(aa));
+ 		CHECK(d=PyNumber_Long(bb));
+ 
+ 		if(SIZE(d)==0) {
+ 			/* divide by zero */
+ 			PyErr_SetString(PyExc_ZeroDivisionError, "Divide by zero");
+ 			goto onError;
+ 		}
+ 
+ 		return PyRational_FromFactors(n, d);
+ 	}
+ 
+ 	/* one argument.  Accept int,long,float, or string */
+ 	if (PyString_Check(aa)) 
+ 		return PyRational_FromString(PyString_AsString(aa), 0);
+ 	else if(PyFloat_Check(aa)) 
+ 		return PyRational_FromDouble(PyFloat_AsDouble(aa));
+ 	else 
+ 		return r_convert(aa);
+ 
+  onError:
+ 	Py_XDECREF(n);
+ 	Py_XDECREF(d);
+ 	return NULL;
+ }
+ 
+ 
+ static void
+ rational_dealloc(PyRational_Object *self)
+ {
+ 	Py_DECREF(self->n);
+ 	Py_DECREF(self->d);
+ 	PyObject_Del(self);
+ }
+ 
+ static int
+ rational_cmp(PyRational_Object *a, PyRational_Object *b)
+ {
+ 	PyObject *ta, *tb;
+ 	int t;
+ 
+ 	ta = PyNumber_Multiply(a->n, b->d);
+ 	tb = PyNumber_Multiply(b->n, a->d);
+ 
+ 	CHECK(ta&&tb);
+ 
+ 	t = PyObject_Compare(ta, tb);
+ 	Py_DECREF(ta);
+ 	Py_DECREF(tb);
+ 
+ 	return t;
+ 
+  onError:
+ 	Py_XDECREF(ta);
+ 	Py_XDECREF(tb);
+ 	return -1;	
+ }
+ 
+ static PyObject *
+ rational_repr(PyRational_Object *self)
+ {
+ 	PyObject *a, *b, *t;
+ 
+ 	a=b=t=NULL;
+ 
+ 	CHECK(a = PyObject_Str(self->n));
+ 	CHECK(b = PyString_FromString("/"));
+ 	CHECK(t = PySequence_Concat(a, b));
+ 	Py_DECREF(a);
+ 	CHECK(a = PyObject_Str(self->d));
+ 	Py_DECREF(b);
+ 	CHECK(b = PySequence_Concat(t, a));
+ 
+ 	Py_DECREF(t);
+ 	Py_DECREF(a);
+ 	return (PyObject *)b;
+ 
+  onError:
+ 	Py_XDECREF(a);
+ 	Py_XDECREF(b);
+ 	Py_XDECREF(t);
+ 	return NULL;
+ }
+ 
+ static long
+ rational_hash(PyRational_Object *self)
+ {
+ 	/* hash the same as all ints and longs if self->d==1 */
+ 	if (SIZE(self->d)==1 && ((PyLongObject *)self->d)->ob_digit[0]==1){
+ 		return PyObject_Hash(self->n);
+ 	}
+ 	else {
+ 		double t;
+ 		t = PyRational_AsDouble((PyObject *)self);
+ 		/* guarantee that large numbers have different hashes */
+ 		if ((t==-1.0 && PyErr_Occurred())) 
+ 			if (PyErr_ExceptionMatches(PyExc_OverflowError)) 
+ 				return PyObject_Hash(self->n) ^ PyObject_Hash(self->d);
+ 			else
+ 				return -1;
+ 		/* this test is for pre-2.2 Python where overflow
+ 		   errors didn't happen */
+ 		else if (Py_IS_INFINITY(t))
+ 			return PyObject_Hash(self->n) ^ PyObject_Hash(self->d);
+ 		else
+ 			return _Py_HashDouble(t);
+ 	}
+ }
+ 
+ static PyObject *
+ x_mul(PyObject *an, PyObject *ad,
+ 	 PyObject *bn, PyObject *bd)
+ {
+ 	PyObject *g1, *g2, *ta, *tb;
+ 	PyObject *zn, *zd;
+ 
+ 	g1=g2=ta=tb=zn=zd=NULL;
+ 
+ 	/************************
+ 	 * g1 = gcd(an, bd)	    *
+ 	 * g2 = gcd(ad, bn)	    *
+ 	 * zn = (an/g1)(bn/g2)  *
+ 	 * zd = (ad/g2)(bd/g1)  *
+ 	 ************************/
+ 	
+ 	CHECK(g1 = factor_gcd(an, bd));
+ 	CHECK(g2 = factor_gcd(ad, bn));
+ 
+ 	CHECK(ta = PyNumber_FloorDivide(an, g1));
+ 	CHECK(tb = PyNumber_FloorDivide(bn, g2));
+ 	CHECK(zn = PyNumber_Multiply(ta, tb));
+ 
+ 	Py_DECREF(ta); 
+ 	CHECK(ta = PyNumber_FloorDivide(ad, g2));
+ 	Py_DECREF(tb);
+ 	CHECK(tb = PyNumber_FloorDivide(bd, g1));
+ 	CHECK(zd = PyNumber_Multiply(ta, tb));
+ 
+ 	Py_DECREF(ta); Py_DECREF(tb);
+ 	Py_DECREF(g1); Py_DECREF(g2);
+ 
+ 	return _PyRational_FROM_FACTORS(zn, zd);
+ 
+  onError:
+ 	Py_XDECREF(g1); Py_XDECREF(g2);
+ 	Py_XDECREF(ta); Py_XDECREF(tb);
+ 	Py_XDECREF(zn); Py_XDECREF(zd);
+ 	return NULL;
+ }
+ 
+ static PyObject *
+ x_add(PyObject *an, PyObject *ad,
+ 	 PyObject *bn, PyObject *bd)
+ {
+ 	PyObject *g1, *g2, *ta, *tb, *tc;
+ 	PyObject *zn, *zd;
+ 
+ 	g1=g2=ta=tb=tc=zn=zd=NULL;
+ 
+ 	CHECK(g1 = factor_gcd(ad, bd));
+ 	if(SIZE(g1)==1 && ((PyLongObject *)g1)->ob_digit[0] == 1) {
+ 		/************************************
+ 		 * zn = (an*bd)+(ad*bn)			 *
+ 		 * zd = (ad*bd)				 *
+ 		 ************************************/
+ 		CHECK(ta = PyNumber_Multiply(an, bd));
+ 		CHECK(tb = PyNumber_Multiply(bn, ad));
+ 		CHECK(zn = PyNumber_Add(ta, tb));
+ 		CHECK(zd = PyNumber_Multiply(ad, bd));
+ 
+ 
+ 		MYDECREF(g1); 
+ 		MYDECREF(ta); MYDECREF(tb);
+ 
+ 	}
+ 	else {
+ 		/*************************************
+ 		 * t = an(bd/g1)+bn(ad/g1)		  *
+ 		 * g2 = gcd(t, g1)				  *
+ 		 * zn = t/g2					  *
+ 		 * zd = (ad/g1)(bd/g2)			  *
+ 		 * See Knuth Vol. 2, Pp 330		  *
+ 		 *************************************/
+ 		CHECK(ta = PyNumber_FloorDivide(bd, g1));
+ 		CHECK(tb = PyNumber_Multiply(an, ta));
+ 		Py_DECREF(ta);
+ 		CHECK(ta = PyNumber_FloorDivide(ad, g1));
+ 		CHECK(tc = PyNumber_Multiply(bn, ta));
+ 		Py_DECREF(ta);
+ 		CHECK(ta = PyNumber_Add(tb, tc));
+ 
+ 
+ 		CHECK(g2 = factor_gcd(ta, g1));
+ 
+ 		CHECK(zn = PyNumber_FloorDivide(ta, g2));
+ 
+ 		Py_DECREF(tb); 
+ 		CHECK(tb = PyNumber_FloorDivide(ad, g1));
+ 		Py_DECREF(tc);
+ 		CHECK(tc = PyNumber_FloorDivide(bd, g2));
+ 		CHECK(zd = PyNumber_Multiply(tb, tc));
+ 
+ 		Py_DECREF(ta);
+ 
+ 		Py_DECREF(tb); Py_DECREF(tc);
+ 		Py_DECREF(g1); Py_DECREF(g2);
+ 	}
+ 
+ 	return _PyRational_FROM_FACTORS(zn, zd);
+  onError:
+ 	Py_XDECREF(g1); Py_XDECREF(g2);
+ 	Py_XDECREF(ta); Py_XDECREF(tb); Py_XDECREF(tc);
+ 	Py_XDECREF(zn); Py_XDECREF(zd);
+ 	return NULL;
+ }
+ 
+ static PyObject *
+ rational_add(PyObject *v, PyObject *w)
+ {
+ 	PyRational_Object *a, *b;
+ 	PyObject *z;
+ 
+ 	CONVERT_BINOP(v, w, &a, &b);
+ 
+ 	z = x_add(a->n, a->d, b->n, b->d);
+ 	Py_DECREF(a);
+ 	Py_DECREF(b);
+ 	return z;
+ }
+ 
+ static PyObject *
+ rational_sub(PyObject *v, PyObject *w)
+ {
+ 	PyRational_Object *a, *b;
+ 	PyObject *z, *t;
+ 
+ 	CONVERT_BINOP(v, w, &a, &b);
+ 
+ 	if(!(t = PyNumber_Negative(b->n))) {
+ 		Py_DECREF(a);
+ 		Py_DECREF(b);
+ 		return NULL;
+ 	}
+ 	z = x_add(a->n, a->d, t, b->d);
+ 	Py_DECREF(a);
+ 	Py_DECREF(b);
+ 	Py_DECREF(t);
+ 	return z;
+ }
+ 	
+ 
+ static PyObject *
+ rational_mul(PyObject *v, PyObject *w)
+ {
+ 	PyRational_Object *a, *b;
+ 	PyObject *z;
+ 
+ 	CONVERT_BINOP(v, w, &a, &b);
+ 
+ 	z= x_mul(a->n, a->d, b->n, b->d);
+ 	Py_DECREF(a);
+ 	Py_DECREF(b);
+ 	return (PyObject *)z;
+ }
+ 
+ 
+ static PyObject *
+ rational_div(PyObject *v, PyObject *w)
+ {
+ 	PyRational_Object *a, *b;
+ 	PyObject *z;
+ 
+ 	CONVERT_BINOP(v, w, &a, &b);
+ 	
+ 	if(SIZE(b->n)==0) {
+ 		PyErr_SetString(PyExc_ZeroDivisionError, "Divide by zero");
+ 		Py_DECREF(a); Py_DECREF(b);
+ 		return NULL;
+ 	}
+ 
+ 	z= x_mul(a->n, a->d, b->d, b->n);
+ 	Py_DECREF(a);
+ 	Py_DECREF(b);
+ 	return z;
+ }
+ 
+ static int
+ x_divmod(PyRational_Object *a, PyRational_Object *b,
+ 	    PyObject **div, PyObject **mod)
+ {
+ 	PyRational_Object *t;
+ 	PyObject *t2;
+ 
+ 	t2=*div=*mod=NULL;
+ 	t=NULL;
+ 	
+ 	if(SIZE(b->n)==0) {
+ 	  PyErr_SetString(PyExc_ZeroDivisionError, "Divide by zero");
+ 	  return -1;
+ 	}
+ 
+ 	CHECK(t = (PyRational_Object *)x_mul(a->n, a->d, b->d, b->n));
+ 	CHECK(t2 = PyNumber_Divmod(t->n, t->d));
+ 	CHECK(*div = PyTuple_GET_ITEM(t2, 0));
+ 	Py_INCREF(*div);
+ 	CHECK(*mod = x_mul(PyTuple_GET_ITEM(t2, 1), t->d, b->n, b->d));
+ 	Py_DECREF(t);
+ 	Py_DECREF(t2);
+ 	return 0;
+ 
+  onError:
+ 	Py_XDECREF(t); Py_XDECREF(t2);
+ 	Py_XDECREF(*div); Py_XDECREF(*mod);
+ 	*div=NULL; *mod=NULL;
+ 	return -1;
+ 
+ }
+ 
+ static PyObject *
+ rational_mod(PyObject *v, PyObject *w)
+ {
+ 	PyRational_Object *a, *b;
+ 	PyObject *div, *mod;
+ 
+ 	CONVERT_BINOP(v, w, &a, &b);
+ 
+ 	if(x_divmod(a, b, &div, &mod)==-1) {
+ 		Py_XDECREF(a);
+ 		Py_XDECREF(b);
+ 		Py_XDECREF(div);
+ 		Py_XDECREF(mod);
+ 		return NULL;
+ 	}
+ 
+ 	Py_DECREF(a);
+ 	Py_DECREF(b);
+ 	Py_DECREF(div);
+ 
+ 	return (PyObject *)mod;
+ }
+ 
+ static PyObject *
+ rational_floor_div(PyObject *v, PyObject *w)
+ {
+ 	PyRational_Object *a, *b;
+ 	PyObject *div, *mod;
+ 	CONVERT_BINOP(v, w, &a, &b);
+ 	
+ 	if(x_divmod(a, b, &div, &mod)==-1) {
+ 		Py_XDECREF(a);
+ 		Py_XDECREF(b);
+ 		Py_XDECREF(div);
+ 		Py_XDECREF(mod);
+ 		return NULL;
+ 	}
+ 
+ 	Py_DECREF(a);
+ 	Py_DECREF(b);
+ 	Py_DECREF(mod);
+ 
+ 	return (PyObject *)div;
+ }
+ 
+ static PyObject *
+ rational_divmod(PyObject *v, PyObject *w)
+ {
+ 	PyRational_Object *a, *b;
+ 	PyObject *div, *mod, *tup;
+ 
+ 	CONVERT_BINOP(v, w, &a, &b);
+ 
+ 	if(x_divmod(a, b, &div, &mod)==-1) return NULL;
+ 
+ 	tup = PyTuple_New(2);
+ 	if(tup!=NULL) {
+ 		PyTuple_SetItem(tup, 0, div);
+ 		PyTuple_SetItem(tup, 1, mod);
+ 	}
+ 	else {
+ 		Py_DECREF(div);
+ 		Py_DECREF(mod);
+ 	}
+ 	Py_DECREF(a);
+ 	Py_DECREF(b);
+ 	return tup;
+ }
+ 
+ 
+ static PyObject *
+ rational_pow(PyObject *bb, PyObject *ee, PyObject *mm)
+ {
+ 	PyObject *zn, *zd, *bn, *bd, *e, *z;
+ 
+ 	e=z=zn=zd=bn=bd=NULL;
+ 	/* don't allow third argument (and give same error as floats) */
+ 	if(mm != Py_None) {
+ 		PyErr_SetString(PyExc_TypeError, "pow() 3rd argument not "
+ 					 "allowed unless all arguments are integers");
+ 		return NULL;
+ 	}
+ 	
+ 	/* switch to floats if ee is a rational */
+ 	if(PyRational_Check(ee)) 
+ 		return PyFloat_Type.tp_as_number->nb_power(bb, ee, mm);
+ 
+ 	/* ensure exp is int or long */
+ 	if(!(PyLong_Check(ee) || PyInt_Check(ee))) {
+ 		Py_INCREF(Py_NotImplemented);
+ 		return Py_NotImplemented;
+ 	}
+ 
+ 	/* convert e to a long */
+ 	e = PyNumber_Long(ee);
+ 	if(e==NULL) {
+ 		Py_INCREF(Py_NotImplemented);
+ 		return Py_NotImplemented;
+ 	}
+ 
+ 	/* invert for negative exponents */
+ 	if(SIZE(e)>=0) {
+ 		PyRational_AsFactors(bb, &bn, &bd);
+ 	}
+ 	else {
+ 		PyRational_AsFactors(bb, &bd, &bn);
+ 		INPLACE1(PyNumber_Absolute, e);
+ 	}
+ 
+ 	/* raise numerator and denominator */
+ 	CHECK(zn = PyNumber_Power(bn, e, Py_None));
+ 	CHECK(zd = PyNumber_Power(bd, e, Py_None));
+ 	z = _PyRational_FROM_FACTORS(zn, zd);
+ 
+ 	Py_DECREF(bn); Py_DECREF(bd);
+ 	Py_DECREF(e);
+ 	return z;
+ 
+  onError:
+ 	Py_XDECREF(e); Py_XDECREF(zn); Py_XDECREF(zd);
+ 	Py_XDECREF(bn); Py_XDECREF(bd);
+ 	return NULL;
+ }
+ 
+ static PyObject *
+ rational_neg(PyRational_Object *self)
+ {
+ 	PyObject *t;
+ 
+ 	if(!(t=PyNumber_Negative(self->n))) return NULL;
+ 	Py_INCREF(self->d);
+ 	return _PyRational_FROM_FACTORS(t, self->d);
+ }
+ 
+ static PyObject *
+ rational_pos(PyRational_Object *self)
+ {
+ 	Py_INCREF(self);
+ 	return (PyObject *)self;
+ }
+ 
+ static PyObject *
+ rational_abs(PyRational_Object *self)
+ {
+ 	if(SIZE(self->n)<0)
+ 		return rational_neg(self);
+ 	else
+ 		return rational_pos(self);
+ }
+ 
+ static int 
+ rational_nonzero(PyRational_Object *self)
+ {
+ 	return SIZE(self->n)!=0;
+ }
+ 
+ static int
+ rational_coerce(PyObject **aa, PyObject **bb)
+ {
+ 	PyObject *z;
+ 
+ 	if((z=r_convert(*bb))==NULL) {
+ 		if(PyErr_Occurred()) {
+ 			return -1;
+ 		}
+ 
+ #ifndef WITHOUT_COMPLEX
+           if(PyComplex_Check(*bb)) {
+                z = PyComplex_FromDoubles(
+                     PyRational_AsDouble(*aa),
+                     (double)0);
+                *aa=z;
+                Py_INCREF(*bb);
+                return 0;
+           }
+ #endif
+ 		
+ 	  /* we don't know how to convert */
+ 	  return 1;
+ 	}
+ 
+ 	*bb = z;
+ 	Py_INCREF(*aa);
+ 	return 0;
+ }
+ 
+ static PyObject *
+ rational_aslong(PyRational_Object *self)
+ {
+ 	return PyNumber_FloorDivide(self->n, self->d);
+ }
+ 
+ static PyObject *
+ rational_asint(PyRational_Object *self)
+ {
+ 	return PyNumber_Int(rational_aslong(self));
+ }
+  
+ static PyObject *
+ rational_asfloat(PyRational_Object *self)
+ {
+ 	double d;
+ 
+ 	d = PyRational_AsDouble((PyObject *)self);
+ 	if(d==-1.0 && PyErr_Occurred()) return NULL;
+ 	else return PyFloat_FromDouble(d);
+ }
+ 
+ 
+ PyDoc_STRVAR(rational_trim_doc__,
+  "R.trim(max_d) -> the closest rational to R with a denominator <= max_d\n");
+ 
+ /************************************************************************
+ ugly, ugly code.  But I couldn't find a more elegant way to express it.
+ *************************************************************************/
+ 
+ static PyObject *
+ r_trim(PyRational_Object *self, PyObject *max_d)
+ {
+ 	PyObject *n, *d,
+ 		*last_n, *last_d,
+ 		*cur_n, *cur_d,
+ 		*next_n, *next_d,
+ 		*blast_n, *blast_d,
+ 		*alt_n, *alt_d,
+ 		*t, *t2, *t3, *z;
+ 	PyObject *div, *mod, *tup;
+ 	PyRational_Object *r, *r1, *r2;
+ 
+ 	/* set everything to NULL */
+ 	n=d=last_n=last_d=cur_n=cur_d=next_n=next_d=NULL;
+ 	blast_n=blast_d=alt_n=alt_d=t=t2=t3=div=mod=tup=z=NULL;
+ 	r=r1=r2=NULL;
+ 
+ 	assert(SIZE(max_d)!=0);
+ 
+ 	/* special case when self->d <= max_d */
+ 	if(PyObject_Compare(self->d, max_d)!=1) {
+ 		Py_INCREF(self);
+ 		return (PyObject *)self;
+ 	}
+ 	
+ 	/* special case when max_d == 1 */
+ 	if ((SIZE(max_d)==1) && (((PyLongObject *)max_d)->ob_digit[0]==1)) {
+ 		CHECK(next_n = PyNumber_FloorDivide(self->n, self->d));
+ 		CHECK(next_d = PyLong_FromLong(1L));
+ 		return _PyRational_FROM_FACTORS(next_n, next_d);
+ 	}
+ 
+ 	n = self->n;
+ 	d = self->d;
+ 	Py_INCREF(n); Py_INCREF(d);
+ 	CHECK(cur_n = PyLong_FromLong(1));
+ 	CHECK(cur_d = PyLong_FromLong(0));
+ 	CHECK(last_n = PyLong_FromLong(0));
+ 	CHECK(last_d = PyLong_FromLong(1));
+ 
+ 	do {
+ 		CHECK(tup = PyNumber_Divmod(n, d));
+ 		CHECK(div = PyTuple_GET_ITEM(tup, 0));
+ 		CHECK(mod = PyTuple_GET_ITEM(tup, 1));
+ 		Py_INCREF(div); Py_INCREF(mod);
+ 		MYDECREF(tup);
+ 		Py_DECREF(n); 
+ 		n = d;
+ 		d = mod;
+ 		mod = NULL;
+ 
+ 		CHECK(t = PyNumber_Multiply(cur_n, div));
+ 		CHECK(next_n = PyNumber_Add(last_n, t));
+ 
+ 		Py_DECREF(t);
+ 		CHECK(t = PyNumber_Multiply(cur_d, div));
+ 		CHECK(next_d = PyNumber_Add(last_d, t));
+ 		MYDECREF(t);
+ 
+ 		Py_XDECREF(blast_n); Py_XDECREF(blast_d);
+ 		blast_n = last_n; blast_d = last_d;
+ 		last_n = cur_n; last_d = cur_d;
+ 		cur_n = next_n; cur_d = next_d;
+ 		next_n = next_d = NULL;
+ 		MYDECREF(div); 
+ 
+ 	} while (SIZE(d)!=0 && PyObject_Compare(cur_d, max_d)==-1) ;
+ 	MYDECREF(n); MYDECREF(d);
+ 	
+ 	if(PyObject_Compare(cur_d, max_d)==0) {
+ 		Py_INCREF(cur_n); Py_INCREF(cur_d);
+ 		z = _PyRational_FROM_FACTORS(cur_n, cur_d);
+ 		goto end;
+ 	}
+ 
+ 	CHECK(t2 = PyNumber_Subtract(max_d, blast_d));
+ 	CHECK(t = PyNumber_FloorDivide(t2, last_d));
+ 
+ 	Py_DECREF(t2);
+ 	CHECK(t2 = PyNumber_Multiply(t, last_n));
+ 	CHECK(alt_n = PyNumber_Add(blast_n, t2));
+ 
+ 	Py_DECREF(t2);
+ 	CHECK(t2 = PyNumber_Multiply(t, last_d));
+ 	CHECK(alt_d = PyNumber_Add(blast_d, t2));
+ 	MYDECREF(t2);
+ 	MYDECREF(t);
+ 
+ 	CHECK(t3 = PyNumber_Negative(self->n));
+ 	CHECK(r = (PyRational_Object *)x_add(alt_n, alt_d, t3, self->d));
+ 	CHECK(r1 = (PyRational_Object *)rational_abs(r));
+ 	
+ 	Py_DECREF(r);
+ 	CHECK(r = (PyRational_Object *)x_add(last_n, last_d, t3, self->d));
+ 	CHECK(r2 = (PyRational_Object *)rational_abs(r));
+ 	MYDECREF(r);
+ 	MYDECREF(t3);
+ 
+ 	if (rational_cmp(r1, r2)==-1) {
+ 		Py_DECREF(r1); Py_DECREF(r2);
+ 		Py_INCREF(alt_n); Py_INCREF(alt_d);
+ 		z = _PyRational_FROM_FACTORS(alt_n, alt_d);
+ 		goto end;
+ 	}
+ 	else {
+ 		Py_DECREF(r1); Py_DECREF(r2);
+ 		Py_INCREF(last_n); Py_INCREF(last_d);
+ 		z = _PyRational_FROM_FACTORS(last_n, last_d);
+ 		goto end;
+ 	}
+ 
+  onError:
+ 	Py_XDECREF(n); Py_XDECREF(d);
+ 	Py_XDECREF(next_n); Py_XDECREF(next_d);
+ 	Py_XDECREF(t); Py_XDECREF(t2); Py_XDECREF(t3);
+ 	Py_XDECREF(r); Py_XDECREF(r1); Py_XDECREF(r2);
+ 	Py_XDECREF(div); Py_XDECREF(mod); Py_XDECREF(tup);
+  end:
+ 	Py_XDECREF(cur_n); Py_XDECREF(cur_d);
+ 	Py_XDECREF(last_n);	 Py_XDECREF(last_d);
+ 	Py_XDECREF(blast_n); Py_XDECREF(blast_d);
+ 	Py_XDECREF(alt_n);	Py_XDECREF(alt_d);
+ 	return (PyObject *)z;
+ }
+ 
+ static PyObject *
+ rational_trim(PyObject *self, PyObject *args)
+ {
+ 	PyObject *max_d;
+ 	PyObject *z;
+ 
+ 	if(!PyArg_ParseTuple(args, "O", &max_d)) return NULL;
+ 	
+ 
+ 	if(!(PyInt_Check(max_d) || PyLong_Check(max_d))) {
+ 		PyErr_Format(PyExc_TypeError,
+ 				   "integer expected, %.80s found",
+ 				   max_d->ob_type->tp_name);
+ 		return NULL;
+ 	}
+ 
+ 	if((max_d = PyNumber_Long(max_d))==NULL) return NULL;
+ 
+ 	z = r_trim((PyRational_Object *)self, max_d);
+ 	Py_DECREF(max_d);
+ 	return z;
+ 
+ }
+ 
+ 
+ static PyMethodDef rational_methods[] = {
+ 	{"trim", rational_trim, METH_VARARGS, rational_trim_doc__},
+ 	{NULL, NULL}
+ };
+ 
+ static PyMemberDef rational_members[] = {
+ 	{"numerator", T_OBJECT, offsetof(PyRational_Object, n), RO,
+ 	 PyDoc_STR("numerator of the reduced fractional representation")},
+ 	{"denominator", T_OBJECT, offsetof(PyRational_Object, d), RO,
+ 	 PyDoc_STR("denominator of the reduced fractional representation")},
+ 	{0},
+ };
+ 
+ static PyNumberMethods PyRationalAsNumber = {
+ 	(binaryfunc)rational_add,	/*nb_add*/
+ 	(binaryfunc)rational_sub,	/*nb_subtract*/
+ 	(binaryfunc)rational_mul,	/*nb_multiply*/
+ 	(binaryfunc)rational_div,	/*nb_divide*/
+ 	(binaryfunc)rational_mod,	/*nb_remainder*/
+ 	(binaryfunc)rational_divmod,	/*nb_divmod*/
+ 	(ternaryfunc)rational_pow,	/*nb_power*/
+ 	(unaryfunc)rational_neg,	/*nb_negative*/
+ 	(unaryfunc)rational_pos,	/*tp_positive*/
+ 	(unaryfunc)rational_abs,	/*tp_absolute*/
+ 	(inquiry)rational_nonzero,	/*tp_nonzero*/
+ 	0,	/*nb_invert*/
+ 	0,	/*nb_lshift*/
+ 	0,	/*nb_rshift*/
+ 	0,	/*nb_and*/
+ 	0,	/*nb_xor*/
+ 	0,	/*nb_or*/
+ 	(coercion)rational_coerce,	/*nb_coerce*/
+ 	(unaryfunc)rational_asint,	/*nb_int*/
+ 	(unaryfunc)rational_aslong,	/*nb_long*/
+ 	(unaryfunc)rational_asfloat,	/*nb_float*/
+ 	0,	/*nb_oct*/
+ 	0,	/*nb_hex*/
+ 	0,				/*nb_inplace_add*/
+ 	0,				/*nb_inplace_subtract*/
+ 	0,				/*nb_inplace_multiply*/
+ 	0,				/*nb_inplace_divide*/
+ 	0,				/*nb_inplace_remainder*/
+ 	0,				/*nb_inplace_power*/
+ 	0,				/*nb_inplace_lshift*/
+ 	0,				/*nb_inplace_rshift*/
+ 	0,				/*nb_inplace_and*/
+ 	0,				/*nb_inplace_xor*/
+ 	0,				/*nb_inplace_or*/
+ 	(binaryfunc)rational_floor_div,	/* nb_floor_divide */
+ 	(binaryfunc)rational_div,	/* nb_true_divide */
+ 	0,			/* nb_inplace_floor_divide */
+ 	0,			/* nb_inplace_true_divide */
+ };
+ 
+ PyTypeObject PyRational_Type = {
+ 	PyObject_HEAD_INIT(&PyType_Type)
+ 	0,
+ 	"rational",
+ 	sizeof(PyRational_Object),
+ 	0,
+ 	(destructor)rational_dealloc,	/*tp_dealloc*/
+ 	0,				/*tp_print*/
+ 	0,					  /*tp_getattr*/
+ 	0,				/*tp_setattr*/
+ 	(cmpfunc)rational_cmp,	/*tp_compare*/
+ 	(reprfunc)rational_repr,	/*tp_repr*/
+ 	&PyRationalAsNumber, /*tp__as_number*/
+ 	0,				/*tp_as_sequence*/
+ 	0,				/*tp_as_mapping*/
+ 	(hashfunc)rational_hash,	  /*tp_hash*/
+ 	0,					/*tp_call*/
+ 	0,				/*tp_str*/
+ 	PyObject_GenericGetAttr,	/*tp_getattro*/
+ 	0,				/*tp_setattro*/
+ 	0,				/*tp_as_buffer*/
+ 	Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES, /*tp_flags*/
+ 	rational_doc,				/* tp_doc */
+ 	0,					/* tp_traverse */
+ 	0,					/* tp_clear */
+ 	0,					/* tp_richcompare */
+ 	0,					/* tp_weaklistoffset */
+ 	0,					/* tp_iter */
+ 	0,					/* tp_iternext */
+ 	rational_methods,			/* tp_methods */
+ 	rational_members,			/* tp_members */
+ 	0,					/* tp_getset */
+ 	0,					/* tp_base */
+ 	0,					/* tp_dict */
+ 	0,					/* tp_descr_get */
+ 	0,					/* tp_descr_set */
+ 	0,					/* tp_dictoffset */
+ 	0,					/* tp_init */
+ 	PyType_GenericAlloc,		/* tp_alloc */
+ 	rational_new,			/* tp_new */
+ };
*** /dev/null	Wed Oct  2 10:57:58 2002
--- Lib/test/test_rational.py	Wed Oct  2 11:26:48 2002
***************
*** 0 ****
--- 1,624 ----
+ from __future__ import nested_scopes, division
+ import unittest
+ import time
+ import math
+ import operator
+ 
+ def fact(n):
+     t = 1L
+     for i in xrange(1, n+1):
+         t*=i
+     return t
+ 
+ def perm(n, s):
+     return fact(s)/(fact(s-n)*fact(n))
+ 
+ def a(a, b, d=0):
+     assert(d >= abs(a-b))
+ 
+ r=rational
+ r0 = r(0, 1)
+ r1 = r(1, 1)
+ r2 = r(2, 1)
+ r_5 = r(1, 2)
+ rn1 = r(-1, 1)
+ rn2 = r(-2, 1)
+     
+ class GeneralTest(unittest.TestCase):
+ 
+     def generalCreate(self):
+         # zero args
+         a(r(), 0)
+ 
+         # one int arg
+         a(r(1), 1)
+         a(r(-1), -1)
+ 
+         # two int args
+         a(r(5, 2), 2.5)
+         a(r(5, -2), -2.5)
+         a(r(-5, 2), -2.5)
+         a(r(-5, -2), 2.5)
+ 
+         # force reduce
+         a(r(9, 24), .375)
+         a(r(12, 2), 6)
+ 
+         # check reduction
+         t = r(9, 24)
+         self.assertEqual(t.numerator, 3)
+         self.assertEqual(t.denominator, 8)
+ 
+         # check negation
+         t = r(1, -1)
+         self.assertEqual(t.numerator, -1)
+         self.assertEqual(t.denominator, 1)
+ 
+         t = r(-1, -1)
+         self.assertEqual(t.numerator, 1)
+         self.assertEqual(t.denominator, 1)
+ 
+         t = r(-1, 1)
+         self.assertEqual(t.numerator, -1)
+         self.assertEqual(t.denominator, 1)
+         
+ 
+         # one long arg
+         a(r(2L**1024), 2L**1024)
+         a(r(-2L**1024), -2L**1024)
+ 
+         # two long args
+         a(r(2L**1024, 2L**24), 2L**1000)
+         a(r(-2L**1024, 2L**24), -2L**1000)
+         a(r(2L**1024, -2L**24), -2L**1000)
+         a(r(-2L**1024, -2L**24), 2L**1000)
+ 
+         # floats
+         a(r(.5), .5)
+         a(r(.2), .2)
+         a(r(math.e), math.e)
+ 
+         # strings
+         self.assertNotEqual(r('.2'), r(.2))
+         a(r('.2'), .2)
+ 
+         # two args, not both ints/longs (illegal)
+         self.assertRaises(TypeError, r, '1.2', 3)
+         self.assertRaises(TypeError, r, 2, '2')
+         self.assertRaises(TypeError, r, 2., 3)
+         self.assertRaises(TypeError, r, 3, 2.)
+         self.assertRaises(TypeError, r, 2., 3.)
+         self.assertRaises(TypeError, r, '.2', '3')
+ 
+         # divide by zero
+         self.assertRaises(ZeroDivisionError, r, 1, 0)
+         self.assertRaises(ZeroDivisionError, r, 1, 0L)
+         self.assertRaises(ZeroDivisionError, r, '1/0')
+ 
+     def generalCreateDiv(self):
+         def r(a=0, b=1):
+             return a/b
+         # zero args
+         a(r(), 0)
+ 
+         # one int arg
+         a(r(1), 1)
+         a(r(-1), -1)
+ 
+         # two int args
+         a(r(5, 2), 2.5)
+         a(r(5, -2), -2.5)
+         a(r(-5, 2), -2.5)
+         a(r(-5, -2), 2.5)
+ 
+         # force reduce
+         a(r(9, 24), .375)
+         a(r(12, 2), 6)
+ 
+         # check reduction
+         t = r(9, 24)
+         self.assertEqual(t.numerator, 3)
+         self.assertEqual(t.denominator, 8)
+ 
+         # check negation
+         t = r(1, -1)
+         self.assertEqual(t.numerator, -1)
+         self.assertEqual(t.denominator, 1)
+ 
+         t = r(-1, -1)
+         self.assertEqual(t.numerator, 1)
+         self.assertEqual(t.denominator, 1)
+ 
+         t = r(-1, 1)
+         self.assertEqual(t.numerator, -1)
+         self.assertEqual(t.denominator, 1)
+         
+ 
+         # one long arg
+         a(r(2L**1024), 2L**1024)
+         a(r(-2L**1024), -2L**1024)
+ 
+         # two long args
+         a(r(2L**1024, 2L**24), 2L**1000)
+         a(r(-2L**1024, 2L**24), -2L**1000)
+         a(r(2L**1024, -2L**24), -2L**1000)
+         a(r(-2L**1024, -2L**24), 2L**1000)
+ 
+         # floats
+         a(r(.5), .5)
+         a(r(.2), .2)
+         a(r(math.e), math.e)
+ 
+         # divide by zero
+         self.assertRaises(ZeroDivisionError, r, 1, 0)
+         self.assertRaises(ZeroDivisionError, r, 1, 0L)
+         
+ 
+     def generalCast(self):
+         a(int(r(25)), 25)
+         a(int(r(25, 5)), 5)
+         a(int(r(26, 5)), 5, 1)
+         
+         a(long(r(2L**1024)), 2L**1024)
+         a(long(r(2L**1024, 2L**24)), 2L**1000)
+         a(float(r(12.5)), 12.5)
+         a(float(r(.2)), .2, 1e-6)
+         a(float(r(math.e)), math.e, 1e-6)
+ 
+         # make sure we can convert then r.d and r.n > max float
+         a(float(r(1L<<1100, (1L<<1102)+1)), .25, 1e-6)
+         a(float(r(1L<<1102, (1L<<1100)+1)), 4., 1e-6)
+         
+         # make sure we can convert when just r.n is > max float
+         # (this is an error in some rationals)
+         a(float(r(1L<<1100, (1L<<1000)+1)), 1L<<100)
+         
+         # test with negatives (just in case)
+         a(float(r(-12, 5)), -12./5, 1e-6)
+         # force all cases in PyRational_AsDouble
+         a(float(r(-(1L<<100), 1)), -(1L<<100))
+         a(float(r(-1, 1L<<100)), -1./(1L<<100))
+         a(float(r(-(1L<<76), 1)), -(1L<<76))
+ 
+ 
+     def generalHash(self):
+         t = rational(12)
+         self.assertEqual(hash(t), hash(int(t)))
+         self.assertEqual(hash(t), hash(long(t))) 
+         self.assertEqual(hash(t), hash(float(t)))
+ 
+         t = rational('12.2')
+         self.assertEqual(hash(t), hash(float(t)))
+ 
+         t = rational(2L**300)
+         self.assertEqual(hash(t), hash(long(t)))
+         self.assertEqual(hash(t), hash(float(t)))
+ 
+         t = rational(2L**300 + 1)
+         self.assertEqual(hash(t), hash(long(t)))
+ 
+         t1 = rational(10L**1000, 3)
+         t2 = rational(10L**1010, 3)
+         self.assertNotEqual(hash(t1), hash(t2))
+ 
+     def generalTruth(self):
+         r = rational
+         self.assert_(r(1))
+         self.assert_(not r(0))
+ 
+     def generalTrim(self):
+         t = rational(2L<<1024, (2L<<32)-1)
+         ttrim = t.trim(2L<<8)
+         small = rational(1, 2L<<8)
+         self.assert_(abs(ttrim-t) < abs(ttrim+small-t))
+         self.assert_(abs(ttrim-t) < abs(ttrim-small-t))
+ 
+     def generalCmp(self):
+         # equal/neq
+         self.assert_(r1 == r1)
+         self.assert_(r1 != r2)
+ 
+         # gt
+         self.assert_(r2 > r1)
+         self.assert_(r1 > r0)
+         self.assert_(r0 > rn1)
+         self.assert_(r1 > rn1)
+         self.assert_(rn1 > rn2)
+         self.assert_(r1 > r_5)
+ 
+         # lt
+         self.assert_(r1 < r2)
+         self.assert_(r0 < r1)
+         self.assert_(rn1 < r0)
+         self.assert_(rn1 < r1)
+         self.assert_(rn2 < rn1)
+         self.assert_(r_5 < r1)
+ 
+         # different types
+         self.assert_(r1 == 1)
+         self.assert_(r2 > 1)
+         self.assert_(r2 > -3)
+         self.assert_(r2 > 1L)
+         self.assert_(r2 > -3L)
+         self.assert_(r2 > 1.)
+         self.assert_(r2 > -3.)
+ 
+         # float compares (debatable)
+         self.assert_(r('.2') == .2)
+ 
+     def generalPickle(self):
+         import pickle, cPickle
+ 
+         t = r(1, 3)
+         p = pickle.dumps(t)
+         a(pickle.loads(p), t)
+         a(cPickle.loads(p), t)
+         self.assert_(cPickle.dumps(t) == p)
+         self.assert_(pickle.loads(pickle.dumps([t]))==[t])
+ 
+ 
+ class MathTest(unittest.TestCase):
+     def simple_neg(self):
+         # neg
+         a(-r1, -1)
+         a(--r1, 1)
+         a(+r1, 1)
+         a(-rn1, 1)
+ 
+     def simple_abs(self):
+         # abs
+         a(abs(r1),1)
+         a(abs(rn1),1)
+ 
+         # test that this doesn't modify the value
+         a(rn1, -1)
+ 
+     def simple_add(self):
+         # addition
+         a(r1+r1, 2)
+         a(r1+r_5, 1.5)
+         a(r1+rn2, -1)
+ 
+         # mixed type
+         a(r1+1, 2)
+         a(r1+1L, 2)
+         a(r1+1.0, 2)
+         a(r1+2j, 1+2j)
+ 
+         # type checks
+         self.assertEqual(type(r1+2.), type(1.))
+         self.assertEqual(type(2.+r1), type(1.))
+         self.assertEqual(type(2+r1), type(r1))
+         self.assertEqual(type(r1+2), type(r1))
+         self.assertEqual(type(2L+r1), type(r1))
+         self.assertEqual(type(r1+2L), type(r1))
+ 
+ 
+         self.assertRaises(TypeError, operator.add, r1, '5')
+ 
+         # force reduction where gcd(ad, bd)!=1
+         a(r(15, 8)+r(19, 4), r(15+19*2, 8))
+ 
+     def simple_sub(self):
+         # subtraction
+         a(r1-r1, 0)
+         a(r1-r_5, .5)
+         a(r1-rn2, 3)
+ 
+         # mixed type
+         a(r1-1, 0)
+         a(r1-1L, 0)
+         a(r1-1.0, 0)
+         a(r1-2, -1)
+         a(r1-2j, 1-2j)
+ 
+         # type checks
+         self.assertEqual(type(r1-2.), type(1.))
+         self.assertEqual(type(2.-r1), type(1.))
+         self.assertEqual(type(2-r1), type(r1))
+         self.assertEqual(type(r1-2), type(r1))
+         self.assertEqual(type(2L-r1), type(r1))
+         self.assertEqual(type(r1-2L), type(r1))
+ 
+ 
+         self.assertRaises(TypeError, operator.sub, r1, '5')
+ 
+     def simple_mul(self):
+         # multiplication
+         a(r1*r2, 2)
+         a(r1*r_5, .5)
+ 
+         # mixed type
+         a(r1*2, 2)
+         a(r1*2L, 2)
+         a(r1*2.0, 2)
+         a(r_5*2j, .5*2j)
+ 
+ 
+         # negation
+         a(r1*rn1, -1)
+         a(rn1*r1, -1)
+         a(rn1*rn1, 1)
+ 
+         # type checks
+         self.assertEqual(type(r1*2.), type(1.))
+         self.assertEqual(type(2.*r1), type(1.))
+         self.assertEqual(type(2*r1), type(r1))
+         self.assertEqual(type(r1*2), type(r1))
+         self.assertEqual(type(2L*r1), type(r1))
+         self.assertEqual(type(r1*2L), type(r1))
+ 
+         self.assertRaises(TypeError, operator.mul, r1, '5')
+ 
+     def simple_div(self):
+         # division
+         a(r1/r2, .5)
+         a(r1/r_5, 2)
+ 
+         # with ints
+         a(r1/2, .5)
+         a(2/r1, 2)
+ 
+         # with longs
+         a(r1/2L, .5)
+         a(2L/r1, 2)
+ 
+         # with floats
+         a(r1/2.0, .5)
+         a(2.0/r1, 2)
+ 
+         # with negatives
+         a(r1/rn1, -1)
+         a(rn1/r1, -1)
+         a(2.0/rn1, -2)
+         a(rn1/2.0, -.5)
+ 
+         # with complex
+         a(r_5/2j, .5/2j)
+ 
+         # type checks        
+         self.assertEqual(type(r1/2.), type(1.))
+         self.assertEqual(type(2./r1), type(1.))
+         self.assertEqual(type(2/r1), type(r1))
+         self.assertEqual(type(r1/2), type(r1))
+         self.assertEqual(type(2L/r1), type(r1))
+         self.assertEqual(type(r1/2L), type(r1))
+         
+ 
+         self.assertRaises(TypeError, operator.div, r1, '5')
+ 
+     def simple_pow(self):
+         #
+         # exponentiation
+         #
+         a(r2**10, 2**10)
+         a(r2**-1, .5)
+         a(r2**r2, 4)
+         a(r2**(1/r2), 2**(.5))
+ 
+         # check types
+         self.assertEqual(type(r2**r2), type(1.))
+         self.assertEqual(type(r2**.5), type(1.))
+         self.assertEqual(type(r2**10), type(r2))
+         self.assertEqual(type(r2**-1), type(r2))
+ 
+         # modular exponents
+         self.assertRaises(TypeError, pow, r2, 6, 3)
+         self.assertRaises(TypeError, pow, 6, r2, 5)
+         self.assertRaises(TypeError, pow, 6, 5, r2)
+ 
+     def simple_mod(self):
+         #
+         # divmod
+         #
+         r17 = r(17)
+         a(divmod(r17, 3)[0], divmod(17, 3)[0])
+         a(divmod(r17, 3)[1], divmod(17, 3)[1])
+         a(divmod(r17, -3)[0], divmod(17, -3)[0])
+         a(divmod(r17, -3)[1], divmod(17, -3)[1])
+         a(divmod(-r17, 3)[0], divmod(-17, 3)[0])
+         a(divmod(-r17, 3)[1], divmod(-17, 3)[1])
+         a(divmod(-r17, -3)[0], divmod(-17, -3)[0])
+         a(divmod(-r17, -3)[1], divmod(-17, -3)[1])
+         
+         r16_5 = r(16, 5)
+         f16_5 = 16.0/5
+         a(divmod(r16_5, 3)[0], divmod(f16_5, 3)[0], 1e-6)
+         a(divmod(r16_5, 3)[1], divmod(f16_5, 3)[1], 1e-6)
+         a(divmod(r16_5, -3)[0], divmod(f16_5, -3)[0], 1e-6)
+         a(divmod(r16_5, -3)[1], divmod(f16_5, -3)[1], 1e-6)
+         a(divmod(-r16_5, 3)[0], divmod(-f16_5, 3)[0], 1e-6)
+         a(divmod(-r16_5, 3)[1], divmod(-f16_5, 3)[1], 1e-6)
+         a(divmod(-r16_5, -3)[0], divmod(-f16_5, -3)[0], 1e-6)
+         a(divmod(-r16_5, -3)[1], divmod(-f16_5, -3)[1], 1e-6)
+ 
+         # exact div
+         r12 = r(12)
+         a(divmod(r12, 3)[0], 4)
+         a(divmod(r12, 3)[1], 0)
+         a(divmod(r12, -3)[0], -4)
+         a(divmod(r12, -3)[1], 0)
+         a(divmod(-r12, 3)[0], -4)
+         a(divmod(-r12, 3)[1], 0)
+         a(divmod(-r12, -3)[0], 4)
+         a(divmod(-r12, -3)[1], 0)
+ 
+ 
+         # mod
+         r17 = r(17)
+         a(r17%3, 17%3)
+         a(r17%-3, 17%-3)
+         a(-r17%3, -17%3)
+         a(-r17%-3, -17%-3)
+         
+         r16_5 = r(16, 5)
+         f16_5 = 16.0/5
+         a(r16_5%3, f16_5%3, 1e-6)
+         a(r16_5%-3, f16_5%-3, 1e-6)
+         a(-r16_5%3, -f16_5%3, 1e-6)
+         a(-r16_5%-3, -f16_5%-3, 1e-6)
+ 
+         # floor div
+         r17 = r(17)
+         a(r17//3, 17//3)
+         a(r17//-3, 17//-3)
+         a(-r17//3, -17//3)
+         a(-r17//-3, -17//-3)
+         
+         r16_5 = r(16, 5)
+         f16_5 = 16.0/5
+         a(r16_5//3, f16_5//3, 1e-6)
+         a(r16_5//-3, f16_5//-3, 1e-6)
+         a(-r16_5//3, -f16_5//3, 1e-6)
+         a(-r16_5//-3, -f16_5//-3, 1e-6)
+ 
+ 
+         self.assertEqual(type(r1%2.), type(1.))
+         self.assertEqual(type(2.%r1), type(1.))
+ 
+ 
+     def simple_bit(self):
+         # shift
+         self.assertRaises(TypeError, operator.rshift, r1, r1)
+         self.assertRaises(TypeError, operator.rshift, r1, 1)
+         self.assertRaises(TypeError, operator.rshift, r1, 1L)
+         self.assertRaises(TypeError, operator.rshift, r1, 1.0)
+         self.assertRaises(TypeError, operator.lshift, r1, r1)
+         self.assertRaises(TypeError, operator.lshift, r1, 1)
+         self.assertRaises(TypeError, operator.lshift, r1, 1L)
+         self.assertRaises(TypeError, operator.lshift, r1, 1.0)
+ 
+         # bitwise
+         self.assertRaises(TypeError, operator.xor, r1, r1)
+         self.assertRaises(TypeError, operator.xor, r1, 1)
+         self.assertRaises(TypeError, operator.xor, r1, 1L)
+         self.assertRaises(TypeError, operator.xor, r1, 1.0)
+         self.assertRaises(TypeError, operator.or_, r1, r1)
+         self.assertRaises(TypeError, operator.or_, r1, 1)
+         self.assertRaises(TypeError, operator.or_, r1, 1L)
+         self.assertRaises(TypeError, operator.or_, r1, 1.0)
+         self.assertRaises(TypeError, operator.and_, r1, r1)
+         self.assertRaises(TypeError, operator.and_, r1, 1)
+         self.assertRaises(TypeError, operator.and_, r1, 1L)
+         self.assertRaises(TypeError, operator.and_, r1, 1.0)
+         self.assertRaises(TypeError, operator.inv, r1)
+ 
+     def simple_math(self):
+         import math
+ 
+         tr = r(1, 5)
+         tf = .2
+ 
+         a(math.acos(tr), math.acos(tf), 1e-6)
+         a(math.asin(tr), math.asin(tf), 1e-6)
+         a(math.atan(tr), math.atan(tf), 1e-6)
+         a(math.ceil(tr), math.ceil(tf), 1e-6)
+         a(math.cos(tr), math.cos(tf), 1e-6)
+         a(math.cosh(tr), math.cosh(tf), 1e-6)
+         a(math.exp(tr), math.exp(tf), 1e-6)
+         a(math.floor(tr), math.floor(tf), 1e-6)
+         a(math.fmod(tr, 2), math.fmod(tf, 2), 1e-6)
+         a(math.hypot(tr, tr), math.hypot(tf, tf), 1e-6)
+         a(math.log(tr), math.log(tf), 1e-6)
+         a(math.log10(tr), math.log10(tf), 1e-6)
+         a(math.modf(tr)[0], math.modf(tf)[0], 1e-6)
+         a(math.modf(tr)[1], math.modf(tf)[1], 1e-6)
+         a(math.sin(tr), math.sin(tf), 1e-6)
+         a(math.sinh(tr), math.sinh(tf), 1e-6)
+         a(math.sqrt(tr), math.sqrt(tf), 1e-6)
+         a(math.tan(tr), math.tan(tf), 1e-6)
+         a(math.tanh(tr), math.tanh(tf), 1e-6)
+ 
+     def long_add(self):
+         # add
+         t = rational()
+         tf = 0.0
+         for i in xrange(1, 1000):
+             t+=rational(1)/i
+             tf+=1.0/i
+         a(t, tf, 1e-6)
+ 
+     def long_sub(self):
+         # sub
+         t = rational()
+         tf = 0.0
+         for i in xrange(1, 1000):
+             t-=rational(1)/i
+             tf-=1.0/i
+         a(t, tf, 1e-6)
+ 
+     def long_mul(self):
+         # mul
+         t = rational(1)
+         tf = 1.0
+         for i in xrange(1, 1000):
+             t = 1/t * i
+             tf = 1/tf * i
+         a(t, tf, 1e-6)
+ 
+     def long_div(self):
+         # div
+         t = rational(1)
+         tf = 1.0
+         for i in xrange(1, 1000):
+             t = i/t
+             tf = i/tf
+         a(t, tf, 1e-6)
+ 
+     def long_pow(self):
+         # exp
+         t = 10L
+         for i in xrange(1, 100):
+             a(rational(i)**t, long(i)**t)
+             a(rational(i, 101)**t, (float(i)/101)**t, 1e-6)
+ 
+         
+     def longPasswdProb(self):
+         # we have a password generator that generates uppper case and
+         # lower case letters, and numbers with probabilities of
+         # 30%, 50%, and 20% respectively
+         # add up the probabilities of each valid password
+         probs = {'upper': rational(30, 100),
+                  'lower': rational(50, 100),
+                  'number': rational(20, 100) }
+         counts = {'upper': 26L,
+                   'lower': 26L,
+                   'number': 10L}
+         length = 12
+ 
+         pupper = probs['upper']/counts['upper']
+         plower = probs['lower']/counts['lower']
+         pnumber = probs['number']/counts['number']
+ 
+         tprob = 0
+         for numlower in xrange(length+1):
+             for numupper in xrange(length+1-numlower):
+                 numnumber = length-numlower-numupper
+ 
+                 # prob of any individual passwd
+                 p_pass = ((pupper**numupper)*
+                           (plower**numlower)*
+                           (pnumber**numnumber))
+ 
+                 # number of passwds
+                 count = (counts['lower']**numlower*
+                          counts['upper']**numupper*
+                          counts['number']**numnumber*
+                          perm(numlower, length)*
+                          perm(numnumber, length-numlower))
+ 
+                 tprob += p_pass*count
+ 
+         self.assertEqual(tprob, 1)
+ 
+ 
+ def suite():
+     suite = unittest.makeSuite(GeneralTest, 'general')
+     suite.addTest(unittest.makeSuite(MathTest, 'simple'))
+     suite.addTest(unittest.makeSuite(MathTest, 'long'))
+     return suite
+ 
+ 
+                   
+ runner = unittest.TextTestRunner()
+ if __name__=="__main__": runner.run(suite())
*** /dev/null	Wed Oct  2 10:57:58 2002
--- Include/rationalobject.h	Wed Oct  2 11:26:55 2002
***************
*** 0 ****
--- 1,21 ----
+ #ifndef Py_RATIONALOBJECT_H
+ #define Py_RATIONALOBJECT_H
+ #ifdef __cplusplus
+ extern "C" 
+ #endif
+ 
+ PyAPI_DATA(PyTypeObject) PyRational_Type;
+ 
+ #define PyRational_Check(op) PyObject_TypeCheck(op, &PyRational_Type)
+ #define PyRational_CheckExact(op) ((op)->ob_type == &PyRational_Type)
+ 
+ PyAPI_FUNC(PyObject *) PyRational_FromFactors(PyObject *, PyObject *);
+ PyAPI_FUNC(void) PyRational_AsFactors(PyObject *, PyObject **, PyObject **);
+ PyAPI_FUNC(PyObject *) PyRational_FromString(char *, char **end);
+ PyAPI_FUNC(PyObject *) PyRational_FromDouble(double);
+ PyAPI_FUNC(double) PyRational_AsDouble(PyObject *);
+ 
+ #ifdef __cplusplus
+ }
+ #endif
+ #endif /* !Py_RATIONALOBJECT_H */

 	  	 
